config/routes.rb
Rails.application.routes.draw do
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  root "contacts#index"

  get "/contacts", to: "contacts#index"
  post "/contacts", to: "contacts#create"
  get "/contacts/new", to: "contacts#new", as: "new_contact"
  get "/contacts/:id", to: "contacts#show", as: "contact"
  get "contacts/:id/edit", to: "contacts#edit", as: "edit_contact"
  patch "contacts/:id", to: "contacts#update"
  delete "contacts/:id", to: "contacts#destroy"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/contact.rb
class Contact < ApplicationRecord
  validates :first_name, presence: true
  validates :last_name, presence: true
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/contacts_controller.rb
class ContactsController < ApplicationController
  def index
    @contacts = Contact.all
  end

  def show
    @contact = Contact.find(params[:id])
  end

  def new
    @contact = Contact.new
  end

  def create
    @contact = Contact.new(contact_params)

    if @contact.save
      redirect_to @contact
    else
      render :new, status: :unprocessable_entity
    end
  end

  def edit
    @contact = Contact.find(params[:id])
  end

  def update
    @contact = Contact.find(params[:id])

    if @contact.update(contact_params)
      redirect_to @contact
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @contact = Contact.find(params[:id])
    @contact.destroy

    redirect_to root_path
  end

  private

  def contact_params
    params.require(:contact).permit(:first_name, :last_name, :phone_number, :description)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/views/contacts/_form.html.erb
<%= form_for contact do |form| %>
  <% if contact.errors.any? %>
    <div id="error_explanation">
      <p><%= contact.errors.full_messages.join(", ") %></p>
    </div>
  <% end %>

  <div>
    <%= form.label :first_name %><br>
    <%= form.text_field :first_name %>
  </div>

  <div>
    <%= form.label :last_name %><br>
    <%= form.text_field :last_name %>
  </div>

  <div>
    <%= form.label :phone_number %><br>
    <%= form.text_field :phone_number %>
  </div>

  <div>
    <%= form.label :description %><br>
    <%= form.text_area :description %>
  </div>

  <div>
    <%= form.submit "Enviar" %>
  </div>
<% end %>

app/views/contacts/edit.html.erb
<h1>Editar Contato</h1>

<%= render "form", contact: @contact %>

app/views/contacts/index.html.erb
<h1>Contatos</h1>

<div>
  <%= link_to "Criar contato", new_contact_path %>
</div>

<% if @contacts.empty? %>
  <h2>Voce ainda nao possui contatos</h2>
<% else %>
  <table class="contacts-table">
    <thead>
      <tr>
        <th>First Name</th>
        <th>Last Name</th>
        <th>Phone Number</th>
        <th></th>
        <th></th>
      </tr>
    </thead>
    <% @contacts.each do |contact| %>
      <tr>
        <td><%=contact.first_name%></td>
        <td><%=contact.last_name%></td>
        <td><%=contact.phone_number%></td>
        <td><%= link_to "Detalhes", contact_path(contact.id) %></td>
        <td><%= link_to "Deletar", contact_path(contact.id), method: :delete, data: { confirm: "Tem certeza?" } %> </td>
      </tr>
    <% end %>
  </table>
<% end %>

app/views/contacts/new.html.erb
<h1>Novo Contato</h1>

<%= render "form", contact: @contact %>

app/views/contacts/show.html.erb
<h1> Contato </h1>

<p><%= @contact.first_name %></p>
<p><%= @contact.last_name %></p>
<p><%= @contact.phone_number %></p>
<p><%= @contact.description %></p>

<%= link_to "Editar", edit_contact_path(@contact.id) %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>ListaTelefonica</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>